import com.trolltech.qt.gui.*;

import ea.presentation.CommonConstants;
import ea.presentation.MenuLogin;

import java.io.*;

class Main
{
	public static boolean DEBUG = false;
	
    public static void main(final String [] args) throws IOException
    {
        System.out.println(CommonConstants.APP_NAME);
        System.setProperty("file.encoding", "UTF-8");

        processArgs(args);
        showDebug();
        init(args);
    }
   
    private static void processArgs(String args[])  
    {
	    if(args.length > 0)
	        for(int i = 0; i < args.length; i++)
	            if(args[i].equals("-d") || args[i].equals("-debug"))
	                DEBUG = true;
    }
    
    private static void init(final String [] args)
    {
    	try
    	{
    		QApplication.initialize(args); 		
    	}
    	catch(java.lang.ExceptionInInitializerError e)
    	{
    		System.err.println("Error: no se encontro la biblioteca QT Jambi");
    		System.exit(-1);
    	}
    	
        new MenuLogin();
        int err = QApplication.exec();
		System.exit(err);
    }
    
	private static void showDebug()
    {
        if(DEBUG || CommonConstants.DEBUG) //Debug mode
        {
            try 
            {
				System.out.println("\n ** Java info **\n" +
				                   "\nVersion: " + System.getProperty("java.version") +
				                   "\nVendor: " + System.getProperty("java.vendor") +
				                   "\nUrl: " + System.getProperty("java.vendor.url") +
				                   "\nHome: " + System.getProperty("java.home") +
				                   "\nPath: " + System.getProperty("java.library.path") +
				                   "\nFile encode: " + System.getProperty("file.encoding") +
				                   "\nCurrent dir: " + new File (".").getCanonicalPath() +
				                   "\nParent  dir: " + new File ("..").getCanonicalPath() +

				                    "\n\n ** OS info ** \n" +
				                   "\nOS name: " + System.getProperty("os.name") +
				                   "\nOS version: " + System.getProperty("os.version") +
				                   "\nOS arch: " + System.getProperty("os.arch"));
			} 
            catch (IOException e) 
			{
				e.printStackTrace();
			}
        }
    }
}
