package domain;

import java.util.LinkedList;
import java.util.Observable;
import java.util.Observer;
import java.util.UUID;

import com.trolltech.qt.QThread;

import ea.domain.stateObservable;
import ea.presentation.Match;
import ea.presentation.MsgOverAttack;

public class ObserverGame implements Observer, Runnable{

	private LinkedList<Match> listGames = new LinkedList<Match>();
	@Override
	public void update(Observable o, Object arg) {
		System.out.println("Estoy en el patron observer");
		stateObservable g = (stateObservable)o;
		Match m = searchMatch(g.getGame());
		Territory tSrc = g.getSrc();
		Territory tDst = g.getDst();
		Arsenal a = g.getArsenal();
		switch(g.getAction())
		{
			case ResolveAttack:
				m.resolveAttack();
				break;
			case Defender:
				MsgOverAttack msg = new MsgOverAttack(m,tSrc.getIdTerritory(),tDst.getIdTerritory(),
						a.getSoldiers(), a.getMissiles(), a.getMissiles(),a.getICBMs());
				QThread ne = new QThread(msg);
				ne.start();
				
				break;
			case Negotiate:
				m.negotiationResolve(tDst.getIdTerritory(),tSrc.getIdTerritory(),g.getSoldier(), g.getMoney());
				
				break;
			case TimeDefenseExpired:
				m.resolveAttack();
				break;
			case TimeNegotiationExpired:
				m.resolveAttack();
				break;
			case TimeTurnExpired:
				m.finishTurn();
				break;
			case UpdateGame:
				//Don't do nothing
				break;
			case TurnChanged:
				m.changedTurn();
				break;
		}
	}
	
	public void addMatch(Match m)
	{
		listGames.add(m);
	}
	
	private Match searchMatch(UUID game)
	{
		Match aux=null;
		for(Match m : listGames) {
			if(game.equals(m.getIdGame())) {
				aux = m;
				break;
			}
		}
		return aux;
	}
	
	@Override
	public void run() {
		// TODO Auto-generated method stub
		
	}

}
