package ea.domain;

import java.util.UUID;

import domain.Spy;
import domain.Territory;

public class InformationSpy 
{
	private Spy spy;
	private UUID idGame;
	private int soldiers;
	private int cannonsOneUse;
	private int cannonsTwoUses;
	private int cannonsThreeUses;
	private int missils;
	private int icbms;
	private int antimissils;
	private int money;
	private boolean success;
	private String owner;
	
	public InformationSpy(UUID idGame, Spy spy, boolean success)
	{
		this.idGame = idGame;
		this.spy = spy;
		this.success = success;
	}
	
	public boolean isSuccess()
	{
		if(success)
			return true;
		else
			return false;
	}
	
	public void setSuccess(boolean success)
	{
		this.success = success;
	}
	
	public Spy getSpy()
	{
		return spy;
	}
	
	public String getOwner()
	{
		return owner;
	}
	
	public void setOwner(String name)
	{
		owner = name;
	}
	
	public void InformationObtainSpy()
	{
		if(success)
		{
			Territory aux = new Territory(spy.getLocation(), null, "", -1, null, -1, -1,-1);
			int pos = ListGames.getGame(idGame).getMap().indexOf(aux);
			if(pos != -1)
			{
				Territory selected = ListGames.getGame(idGame).getMap().get(pos);
				setSoldiers(selected.getNumSoldiers());
				setCannonsOneUse(selected.getNumCannons()[0]);
				setCannonsTwoUses(selected.getNumCannons()[1]);
				setCannonsThreeUses(selected.getNumCannons()[2]);
				setMissls(selected.getNumMissiles());
				setICBMs(selected.getNumMissiles());
				setAntimissils(selected.getNumAntiMissiles());
				setMoney(new QueryMoney(idGame,selected.getOwner()).getMoney());
				setOwner(selected.getOwner());
			}
		}
	}
	
	private void setSoldiers(int soldiers)
	{
		this.soldiers = soldiers;
	}

	private void setCannonsOneUse(int cannonsOneUse)
	{
		this.cannonsOneUse = cannonsOneUse;
	}
	
	private void setCannonsTwoUses(int cannonsTwoUses)
	{
		this.cannonsTwoUses = cannonsTwoUses;
	}
	
	private void setCannonsThreeUses(int cannonsThreeUses)
	{
		this.cannonsThreeUses = cannonsThreeUses;
	}
	
	private void setMissls(int missils)
	{
		this.missils = missils;
	}
	
	private void setICBMs(int icbms)
	{
		this.icbms = icbms;
	}
	
	private void setAntimissils(int antimissils)
	{
		this.antimissils = antimissils;
	}
	
	private void setMoney(int money)
	{
		this.money = money;
	}
	
	public int getSoldiers()
	{
		return soldiers;
	}
	
	public int getCannonsOneUse()
	{
		return cannonsOneUse;
	}
	
	public int getCannonsTwoUses()
	{
		return cannonsTwoUses;
	}
	
	public int getCannonsThreeUses()
	{
		return cannonsThreeUses;
	}
	
	public int getMissils()
	{
		return missils;
	}
	
	public int getICBMs()
	{
		return icbms;
	}
	
	public int getAntimissils()
	{
		return antimissils;
	}
	
	public int getMoney()
	{
		 return money;
	}
	
	public void decrementUse()
	{
		spy.setUses(spy.getUses()-1);
	}
	
	public int getUsesSpy()
	{
		return spy.getUses();
	}
	
	public int getLocationSpy()
	{
		return spy.getLocation();
	}
}
