package ea.domain;

import java.rmi.RemoteException;

import com.trolltech.qt.QThread;

import domain.GameListener;
import domain.ObserverGame;
import ea.exceptions.NullInformationException;
import ea.presentation.Match;

public class Listener 
{
	private static GameListener listener = null;
	private static ObserverGame observer = null;
	private static stateObservable observable = null;
	
	public Listener()
	{
	}
	
	private static void createObserver()
	{
		observer = new ObserverGame();
	}
	
	public static void initializeListener(String name)throws NullInformationException, 
															 RemoteException
	{
		if(name==null)
			throw new NullInformationException("El nombre del jugador asignado al listener es nulo.");
		
		if(name.isEmpty())
			throw new NullInformationException("El nombre del jugador asignado al listener es vaco.");
		
		Listener.createObserver();
		Listener.createStateObservable(name);
		Listener.createGameListener();
		Listener.startObserver();
	}
	
	private static void createStateObservable(String name)throws NullInformationException
	{
		observable = new stateObservable(name);
		observable.addObserver(getObserver());
		observable.notifyObservers();
	}
	
	private static void createGameListener()throws NullInformationException, RemoteException
	{
		listener = new GameListener(getObservable());
	}
	
	public static void addMatchObserver(Match game)throws NullInformationException
	{
		if(game == null)
			throw new NullInformationException("El game que se aade al observador es nulo.");
			
		getObserver().addMatch(game);
	}
	
	public static GameListener getListener() throws NullInformationException
	{
		if(listener == null)
			throw new NullInformationException("El objeto game listener es nulo.");
		return listener;
	}
	
	public static stateObservable getObservable()throws NullInformationException
	{
		if(observable == null)
			throw new NullInformationException("El objeto state observable es nulo.");
		return observable;
	}
	
	public static ObserverGame getObserver()throws NullInformationException
	{
		if(observer == null)
			throw new NullInformationException("El objeto observer game es nulo.");
		return observer;
	}
	
	private static void startObserver()throws NullInformationException
	{
		QThread runner = new QThread(getObserver());
		runner.start();
	}
}
