package ea.domain;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.UUID;

import domain.Game;
import domain.Territory;
import ea.libs.graphs.*;
import ea.libs.lists.Lista;
import ea.libs.Color;
import ea.libs.Constants;

public class Map extends GrafoNV<Territories> {
	private UUID idGame;
	private int selectedTerritory;
	private Territories[] mapTerritories = new Territories[Constants.totalTerritories];
	private Hashtable<Color, Territories> tableHash = new Hashtable<Color, Territories>();

	public Map(UUID idGame) {
		super();
		this.idGame = idGame;
		selectedTerritory = 42;
		for (int i = 0; i < Constants.totalTerritories; i++) {
			mapTerritories[i] = new Territories(i, Constants.colors[i],
					Constants.prices[i], Names.values()[i]);
			insertarVertice(mapTerritories[i]);
			tableHash.put(Constants.colors[i], mapTerritories[i]);/*
																 * Hash table
																 * <color,
																 * territorio>
																 */
		}

		insertarArco(mapTerritories[0], mapTerritories[1]);
		insertarArco(mapTerritories[0], mapTerritories[2]);
		insertarArco(mapTerritories[0], mapTerritories[3]);
		insertarArco(mapTerritories[0], mapTerritories[6]);

		insertarArco(mapTerritories[1], mapTerritories[0]);
		insertarArco(mapTerritories[1], mapTerritories[3]);
		insertarArco(mapTerritories[1], mapTerritories[29]);

		insertarArco(mapTerritories[2], mapTerritories[0]);
		insertarArco(mapTerritories[2], mapTerritories[3]);
		insertarArco(mapTerritories[2], mapTerritories[4]);
		insertarArco(mapTerritories[2], mapTerritories[5]);
		insertarArco(mapTerritories[2], mapTerritories[6]);

		insertarArco(mapTerritories[3], mapTerritories[0]);
		insertarArco(mapTerritories[3], mapTerritories[1]);
		insertarArco(mapTerritories[3], mapTerritories[2]);
		insertarArco(mapTerritories[3], mapTerritories[5]);

		insertarArco(mapTerritories[4], mapTerritories[6]);
		insertarArco(mapTerritories[4], mapTerritories[2]);
		insertarArco(mapTerritories[4], mapTerritories[5]);
		insertarArco(mapTerritories[4], mapTerritories[13]);
		insertarArco(mapTerritories[4], mapTerritories[21]);
		insertarArco(mapTerritories[4], mapTerritories[23]);

		insertarArco(mapTerritories[5], mapTerritories[3]);
		insertarArco(mapTerritories[5], mapTerritories[2]);
		insertarArco(mapTerritories[5], mapTerritories[4]);
		insertarArco(mapTerritories[5], mapTerritories[17]);
		insertarArco(mapTerritories[5], mapTerritories[7]);
		insertarArco(mapTerritories[5], mapTerritories[13]);

		insertarArco(mapTerritories[6], mapTerritories[0]);
		insertarArco(mapTerritories[6], mapTerritories[2]);
		insertarArco(mapTerritories[6], mapTerritories[4]);
		insertarArco(mapTerritories[6], mapTerritories[23]);

		insertarArco(mapTerritories[7], mapTerritories[5]);
		insertarArco(mapTerritories[7], mapTerritories[17]);
		insertarArco(mapTerritories[7], mapTerritories[8]);
		insertarArco(mapTerritories[7], mapTerritories[9]);
		insertarArco(mapTerritories[7], mapTerritories[13]);

		insertarArco(mapTerritories[8], mapTerritories[7]);
		insertarArco(mapTerritories[8], mapTerritories[9]);
		insertarArco(mapTerritories[8], mapTerritories[17]);
		insertarArco(mapTerritories[8], mapTerritories[16]);
		insertarArco(mapTerritories[8], mapTerritories[14]);
		insertarArco(mapTerritories[8], mapTerritories[15]);

		insertarArco(mapTerritories[9], mapTerritories[13]);
		insertarArco(mapTerritories[9], mapTerritories[7]);
		insertarArco(mapTerritories[9], mapTerritories[8]);
		insertarArco(mapTerritories[9], mapTerritories[15]);

		insertarArco(mapTerritories[10], mapTerritories[14]);
		insertarArco(mapTerritories[10], mapTerritories[16]);
		insertarArco(mapTerritories[10], mapTerritories[18]);
		insertarArco(mapTerritories[10], mapTerritories[12]);

		insertarArco(mapTerritories[11], mapTerritories[12]);
		insertarArco(mapTerritories[11], mapTerritories[14]);

		insertarArco(mapTerritories[12], mapTerritories[11]);
		insertarArco(mapTerritories[12], mapTerritories[14]);
		insertarArco(mapTerritories[12], mapTerritories[10]);
		insertarArco(mapTerritories[12], mapTerritories[18]);
		insertarArco(mapTerritories[12], mapTerritories[25]);

		insertarArco(mapTerritories[13], mapTerritories[4]);
		insertarArco(mapTerritories[13], mapTerritories[5]);
		insertarArco(mapTerritories[13], mapTerritories[7]);
		insertarArco(mapTerritories[13], mapTerritories[9]);
		insertarArco(mapTerritories[13], mapTerritories[21]);

		insertarArco(mapTerritories[14], mapTerritories[8]);
		insertarArco(mapTerritories[14], mapTerritories[16]);
		insertarArco(mapTerritories[14], mapTerritories[10]);
		insertarArco(mapTerritories[14], mapTerritories[12]);
		insertarArco(mapTerritories[14], mapTerritories[11]);

		insertarArco(mapTerritories[15], mapTerritories[39]);
		insertarArco(mapTerritories[15], mapTerritories[9]);
		insertarArco(mapTerritories[15], mapTerritories[8]);

		insertarArco(mapTerritories[16], mapTerritories[17]);
		insertarArco(mapTerritories[16], mapTerritories[8]);
		insertarArco(mapTerritories[16], mapTerritories[14]);
		insertarArco(mapTerritories[16], mapTerritories[10]);
		insertarArco(mapTerritories[16], mapTerritories[18]);

		insertarArco(mapTerritories[17], mapTerritories[5]);
		insertarArco(mapTerritories[17], mapTerritories[7]);
		insertarArco(mapTerritories[17], mapTerritories[8]);
		insertarArco(mapTerritories[17], mapTerritories[16]);

		insertarArco(mapTerritories[18], mapTerritories[10]);
		insertarArco(mapTerritories[18], mapTerritories[12]);
		insertarArco(mapTerritories[18], mapTerritories[16]);

		insertarArco(mapTerritories[19], mapTerritories[20]);
		insertarArco(mapTerritories[19], mapTerritories[23]);
		insertarArco(mapTerritories[19], mapTerritories[24]);

		insertarArco(mapTerritories[20], mapTerritories[19]);
		insertarArco(mapTerritories[20], mapTerritories[21]);
		insertarArco(mapTerritories[20], mapTerritories[23]);
		insertarArco(mapTerritories[20], mapTerritories[24]);
		insertarArco(mapTerritories[20], mapTerritories[22]);

		insertarArco(mapTerritories[21], mapTerritories[4]);
		insertarArco(mapTerritories[21], mapTerritories[13]);
		insertarArco(mapTerritories[21], mapTerritories[23]);
		insertarArco(mapTerritories[21], mapTerritories[20]);

		insertarArco(mapTerritories[22], mapTerritories[20]);
		insertarArco(mapTerritories[22], mapTerritories[24]);

		insertarArco(mapTerritories[23], mapTerritories[6]);
		insertarArco(mapTerritories[23], mapTerritories[4]);
		insertarArco(mapTerritories[23], mapTerritories[21]);
		insertarArco(mapTerritories[23], mapTerritories[20]);
		insertarArco(mapTerritories[23], mapTerritories[19]);

		insertarArco(mapTerritories[24], mapTerritories[22]);
		insertarArco(mapTerritories[24], mapTerritories[20]);
		insertarArco(mapTerritories[24], mapTerritories[19]);

		insertarArco(mapTerritories[25], mapTerritories[26]);
		insertarArco(mapTerritories[25], mapTerritories[30]);
		insertarArco(mapTerritories[25], mapTerritories[12]);

		insertarArco(mapTerritories[26], mapTerritories[25]);
		insertarArco(mapTerritories[26], mapTerritories[30]);
		insertarArco(mapTerritories[26], mapTerritories[31]);
		insertarArco(mapTerritories[26], mapTerritories[33]);

		insertarArco(mapTerritories[27], mapTerritories[28]);
		insertarArco(mapTerritories[27], mapTerritories[33]);
		insertarArco(mapTerritories[27], mapTerritories[37]);

		insertarArco(mapTerritories[28], mapTerritories[27]);
		insertarArco(mapTerritories[28], mapTerritories[33]);
		insertarArco(mapTerritories[28], mapTerritories[31]);
		insertarArco(mapTerritories[28], mapTerritories[32]);

		insertarArco(mapTerritories[29], mapTerritories[30]);
		insertarArco(mapTerritories[29], mapTerritories[31]);
		insertarArco(mapTerritories[29], mapTerritories[32]);
		insertarArco(mapTerritories[29], mapTerritories[1]);

		insertarArco(mapTerritories[30], mapTerritories[25]);
		insertarArco(mapTerritories[30], mapTerritories[26]);
		insertarArco(mapTerritories[30], mapTerritories[31]);
		insertarArco(mapTerritories[30], mapTerritories[29]);

		insertarArco(mapTerritories[31], mapTerritories[29]);
		insertarArco(mapTerritories[31], mapTerritories[30]);
		insertarArco(mapTerritories[31], mapTerritories[32]);
		insertarArco(mapTerritories[31], mapTerritories[26]);
		insertarArco(mapTerritories[31], mapTerritories[33]);
		insertarArco(mapTerritories[31], mapTerritories[28]);

		insertarArco(mapTerritories[32], mapTerritories[29]);
		insertarArco(mapTerritories[32], mapTerritories[31]);
		insertarArco(mapTerritories[32], mapTerritories[28]);

		insertarArco(mapTerritories[33], mapTerritories[26]);
		insertarArco(mapTerritories[33], mapTerritories[31]);
		insertarArco(mapTerritories[33], mapTerritories[28]);
		insertarArco(mapTerritories[33], mapTerritories[27]);

		insertarArco(mapTerritories[34], mapTerritories[35]);
		insertarArco(mapTerritories[34], mapTerritories[36]);

		insertarArco(mapTerritories[35], mapTerritories[34]);
		insertarArco(mapTerritories[35], mapTerritories[36]);
		insertarArco(mapTerritories[35], mapTerritories[37]);
		insertarArco(mapTerritories[35], mapTerritories[23]);

		insertarArco(mapTerritories[36], mapTerritories[34]);
		insertarArco(mapTerritories[36], mapTerritories[35]);
		insertarArco(mapTerritories[36], mapTerritories[37]);

		insertarArco(mapTerritories[37], mapTerritories[27]);
		insertarArco(mapTerritories[37], mapTerritories[35]);
		insertarArco(mapTerritories[37], mapTerritories[36]);

		insertarArco(mapTerritories[38], mapTerritories[40]);
		insertarArco(mapTerritories[38], mapTerritories[41]);

		insertarArco(mapTerritories[39], mapTerritories[40]);
		insertarArco(mapTerritories[39], mapTerritories[41]);
		insertarArco(mapTerritories[39], mapTerritories[15]);

		insertarArco(mapTerritories[40], mapTerritories[39]);
		insertarArco(mapTerritories[40], mapTerritories[41]);
		insertarArco(mapTerritories[40], mapTerritories[38]);

		insertarArco(mapTerritories[41], mapTerritories[38]);
		insertarArco(mapTerritories[41], mapTerritories[39]);
		insertarArco(mapTerritories[41], mapTerritories[40]);
	}

	public Names[] getTerritory() {
		return Names.values();
	}

	public int getSelectedTerritory() {
		return this.selectedTerritory;
	}

	public int getNumSoldiersTerritorySelected(int idTerritory) {
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame)
				.getMap();
		Territory aux = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = listTerritories.indexOf(aux);
		if (pos != -1)
			return listTerritories.get(pos).getNumSoldiers();
		else
			return -1;
	}

	public int[] getNumCannonsTerritorySelected(int idTerritory) {
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame)
				.getMap();
		Territory aux = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = listTerritories.indexOf(aux);
		if (pos != -1)
			return listTerritories.get(pos).getNumCannons();
		else
			return new int[] { -1, -1, -1 };
	}

	public int getNumMissilesTerritorySelected(int idTerritory) {
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame)
				.getMap();
		Territory aux = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = listTerritories.indexOf(aux);
		if (pos != -1)
			return listTerritories.get(pos).getNumMissiles();
		else
			return -1;
	}

	public int getNumICBMsTerritorySelected(int idTerritory) {
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame)
				.getMap();
		Territory aux = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = listTerritories.indexOf(aux);
		if (pos != -1)
			return listTerritories.get(pos).getNumICBMs();
		else
			return -1;
	}

	public int getNumAntiMissilesTerritorySelected(int idTerritory) {
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame)
				.getMap();
		Territory aux = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = listTerritories.indexOf(aux);
		if (pos != -1)
			return listTerritories.get(pos).getNumAntiMissiles();
		else
			return -1;
	}

	public void setSelectedTerritory(int territory) {
		this.selectedTerritory = territory;
	}

	public Territory getTerritory(int idTerritory) {
		Game game = ListGames.getGame(this.idGame);
		ArrayList<Territory> territories = game.getMap();
		Territory aux1 = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = territories.indexOf(aux1);

		Territory selected = territories.get(pos);
		return selected;
	}
	
	public int getContinent(int idTerritory) {
		Territory aux = this.getTerritory(idTerritory);
		return aux.getContinent().ordinal();
	}
	

	public Names getTerritoryName(int territory) {
		return getTerritory()[territory];
	}

	private Territories getVertexByColor(Color color) {
		Territories territorie;
		if (tableHash.containsKey(color))
			territorie = tableHash.get(color);
		else
			territorie = null;
		return territorie;
	}

	public Names searchTerritoryName(int a, int r, int g, int b) {
		Names territoryName = Names.Ninguno;
		Color color = new Color(a, r, g, b);
		Territories aux = getVertexByColor(color);
		if (aux != null) {
			territoryName = aux.getName();
			selectedTerritory = aux.getId();
		}

		return territoryName;
	}

	public ArrayList<Integer> occupiedAdyacentTerritories(int a, int r, int g,
			int b) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Color color = new Color(a, r, g, b);
		Territories aux = new Territories(-1, color, -1, Names.Ninguno);
		Lista<Territories> neighbors = this.adyacentes(aux);
		Game game = ListGames.getGame(this.idGame);

		while (!neighbors.esVacia()) {
			Territories explore = neighbors.primero();
			Territory aux1 = new Territory(explore.getId(), null, "", -1, null,
					-1, -1, -1);

			int pos = game.getMap().indexOf(aux1);
			if (!(game.getMap().get(pos).getOwner() == null || game.getMap()
					.get(pos).getOwner().equals("")))
				results.add(game.getMap().get(pos).getIdTerritory());

			neighbors = neighbors.resto();
		}
		return results;
	}

	public ArrayList<Integer> myTerritories(String player) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Iterator<Territory> iter = ListGames.getGame(this.idGame).getMap()
				.iterator();

		while (iter.hasNext()) {
			Territory t = iter.next();
			if (t.getOwner().equals(player))
				results.add(t.getIdTerritory());
		}

		return results;
	}

	public ArrayList<Integer> ownersAdyacentTerritories(int a, int r, int g,
			int b, String player) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Color color = new Color(a, r, g, b);
		Territories aux = new Territories(-1, color, -1, Names.Ninguno);
		Lista<Territories> neighbors = this.adyacentes(aux);
		Game game = ListGames.getGame(this.idGame);

		while (!neighbors.esVacia()) {
			Territories explore = neighbors.primero();
			Territory aux1 = new Territory(explore.getId(), null, "", -1, null,
					-1, -1, -1);

			int pos = game.getMap().indexOf(aux1);
			if (game.getMap().get(pos).getOwner() != null
					&& game.getMap().get(pos).getOwner().equals(player))
				results.add(game.getMap().get(pos).getIdTerritory());

			neighbors = neighbors.resto();
		}
		return results;
	}
	
	public ArrayList<Integer> ownersTerritories(String player) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Territories[] territories = this.getTerritories();
		Game game = ListGames.getGame(this.idGame);
		
		for(int i=0; i< Constants.totalTerritories; i++ ){
			Territory aux1 = new Territory(territories[i].getId(), null, "", -1, null,
					-1, -1, -1);
			int pos = game.getMap().indexOf(aux1);
			if (game.getMap().get(pos).getOwner() != null
					&& game.getMap().get(pos).getOwner().equals(player))
				results.add(game.getMap().get(pos).getIdTerritory());
		}
		return results;
	}

	public ArrayList<Integer> freeAdyacentTerritories(int a, int r, int g, int b) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Color color = new Color(a, r, g, b);
		Territories aux = new Territories(-1, color, -1, Names.Ninguno);
		Lista<Territories> neighbors = this.adyacentes(aux);
		Game game = ListGames.getGame(this.idGame);

		while (!neighbors.esVacia()) {
			Territories explore = neighbors.primero();
			Territory aux1 = new Territory(explore.getId(), null, "", -1, null,
					-1, -1, -1);

			int pos = game.getMap().indexOf(aux1);
			if (game.getMap().get(pos).getOwner() == null
					|| game.getMap().get(pos).getOwner().equals(""))
				results.add(game.getMap().get(pos).getIdTerritory());

			neighbors = neighbors.resto();
		}
		return results;
	}
	
	public Territories[] getTerritories(){
		return this.mapTerritories;
	}
	
	public ArrayList<Integer> freeTerritories() {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Territories[] territories = this.getTerritories();
		Game game = ListGames.getGame(this.idGame);
		
		for(int i=0; i< Constants.totalTerritories; i++ ){
			Territory aux1 = new Territory(territories[i].getId(), null, "", -1, null,
					-1, -1, -1);
			int pos = game.getMap().indexOf(aux1);
			if (game.getMap().get(pos).getOwner() == null
					|| game.getMap().get(pos).getOwner().equals(""))
				results.add(game.getMap().get(pos).getIdTerritory());
		}
		return results;
	}
	
	public ArrayList<Integer> freeTerritoriesContinent(int continentSelected) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Territories[] territories = this.getTerritories();
		Game game = ListGames.getGame(this.idGame);
		
		for(int i=0; i< Constants.totalTerritories; i++ ){
			Territory aux1 = new Territory(territories[i].getId(), null, "", -1, null,
					-1, -1, -1);
			int pos = game.getMap().indexOf(aux1);
			if ((game.getMap().get(pos).getOwner() == null
					|| game.getMap().get(pos).getOwner().equals(""))
					&& game.getMap().get(pos).getContinent().ordinal() == continentSelected)
				results.add(game.getMap().get(pos).getIdTerritory());
		}
		return results;
	}
	
	public ArrayList<Integer> occupiedTerritoriesContinent(int continentSelected) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Territories[] territories = this.getTerritories();
		Game game = ListGames.getGame(this.idGame);
		
		for(int i=0; i< Constants.totalTerritories; i++ ){
			Territory aux1 = new Territory(territories[i].getId(), null, "", -1, null,
					-1, -1, -1);
			int pos = game.getMap().indexOf(aux1);
			if (!(game.getMap().get(pos).getOwner() == null
					|| game.getMap().get(pos).getOwner().equals(""))
					&& game.getMap().get(pos).getContinent().ordinal() == continentSelected)
				results.add(game.getMap().get(pos).getIdTerritory());
		}
		return results;
	}

	public boolean isOwnsTerritory(int idTerritory, String playerName) {
		Game game = ListGames.getGame(this.idGame);
		ArrayList<Territory> territories = game.getMap();
		Territory aux1 = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = territories.indexOf(aux1);

		Territory selected = territories.get(pos);
		return playerName.equals(selected.getOwner());
	}

	public void setArsenalTerritory(int idTerritory, int numSoldiers,
			int numCannons1, int numCannons2, int numCannons3, int numMissils,
			int numMissilsICB, int numAntiMissils) {
		Game game = ListGames.getGame(this.idGame);
		ArrayList<Territory> territories = game.getMap();
		Territory aux1 = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = territories.indexOf(aux1);

		Territory selected = territories.get(pos);
		selected.setNumSoldiers(numSoldiers);
		int[] newCannons = { numCannons1, numCannons2, numCannons3 };
		selected.setNumCannons(newCannons);
		selected.setNumMissiles(numMissils);
		selected.setNumICBMs(numMissilsICB);
		selected.setNumAntiMissiles(numAntiMissils);
	}

	public void buyArsenal(int idTerritory, int numSoldiers, int numCannons,
			int numMissils, int numICBMs, int numAntiMissils) {
		Game game = ListGames.getGame(this.idGame);
		ArrayList<Territory> territories = game.getMap();
		Territory aux1 = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = territories.indexOf(aux1);

		Territory selected = territories.get(pos);

		selected.setNumSoldiers(numSoldiers + selected.getNumSoldiers());
		selected.getNumCannons()[2] = selected.getNumCannons()[2] + numCannons;
		selected.setNumMissiles(numMissils + selected.getNumMissiles());
		selected.setNumICBMs(numICBMs + selected.getNumICBMs());
		selected.setNumAntiMissiles(numAntiMissils
				+ selected.getNumAntiMissiles());
	}

	public ArrayList<Integer> freeAdyacentTerritoriesToBuy(int a, int r, int g,
			int b, int money) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Color color = new Color(a, r, g, b);
		Territories aux = new Territories(-1, color, -1, Names.Ninguno);
		Lista<Territories> neighbors = this.adyacentes(aux);
		Game game = ListGames.getGame(this.idGame);

		while (!neighbors.esVacia()) {
			Territories explore = neighbors.primero();
			Territory aux1 = new Territory(explore.getId(), null, "", -1, null,
					-1, -1, -1);
			int pos = game.getMap().indexOf(aux1);
			if ((game.getMap().get(pos).getOwner() == null || game.getMap()
					.get(pos).getOwner().equals(""))
					&& (money >= Constants.prices[game.getMap().get(pos)
							.getIdTerritory()]))
				results.add(game.getMap().get(pos).getIdTerritory());

			neighbors = neighbors.resto();

		}
		return results;
	}

	public void buyTerritory(int idTerritory, String namePlayer) {
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame)
				.getMap();
		Territory aux = new Territory(idTerritory, null, "", -1, null, -1, -1,
				-1);
		int pos = listTerritories.indexOf(aux);
		listTerritories.get(pos).setOwner(namePlayer);
	}

	public ArrayList<Integer> freeAdyacentTerritoriesNotToBuy(int a, int r,
			int g, int b, int money) {
		ArrayList<Integer> results = new ArrayList<Integer>();
		Color color = new Color(a, r, g, b);
		Territories aux = new Territories(-1, color, -1, Names.Ninguno);
		Lista<Territories> neighbors = this.adyacentes(aux);
		Game game = ListGames.getGame(this.idGame);

		while (!neighbors.esVacia()) {
			Territories explore = neighbors.primero();
			Territory aux1 = new Territory(explore.getId(), null, "", -1, null,
					-1, -1, -1);
			int pos = game.getMap().indexOf(aux1);
			if ((game.getMap().get(pos).getOwner() == null || game.getMap()
					.get(pos).getOwner().equals(""))
					&& (money < Constants.prices[explore.getId()]))
				results.add(explore.getId());

			neighbors = neighbors.resto();

		}
		return results;
	}

	public boolean correctTerritoryOverlandAttack(int idTerritory)
	{
		if(this.getTerritory(idTerritory).getNumSoldiers()> 1)
			return true;
		else
		{//Territory has one soldiers
			if(this.getTerritory(idTerritory).getNumCannons()[0] == 0 &&
					this.getTerritory(idTerritory).getNumCannons()[1] == 0 &&
					this.getTerritory(idTerritory).getNumCannons()[2] == 0)
				return false;
			else
				return true;
		}
	}
	
	public boolean correctTerritoryICBM(int idTerritory) {
		if (this.getTerritory(idTerritory).getNumICBMs() > 0)
			return true;
		else
			return false;
	}
	
	public boolean correctTerritoryMissile(int idTerritory) {
		if (this.getTerritory(idTerritory).getNumMissiles() > 0)
			return true;
		else
			return false;
	}
	
	public String getNamebyIdTerritory (int idTerritory)
	{
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame).getMap();
        Territory aux = new Territory(idTerritory,null,"",-1,null,-1,-1,-1);
        int pos = listTerritories.indexOf(aux);
        if(pos != -1)
        	return listTerritories.get(pos).getOwner();
        else return null;
	}
	
	public void sumSoldier(int idTerritory, int soldiers)
	{
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame).getMap();
        Territory aux = new Territory(idTerritory,null,"",-1,null,-1,-1,-1);
        int pos = listTerritories.indexOf(aux);
        Territory t = listTerritories.get(pos);
        t.setNumSoldiers(t.getNumSoldiers()+soldiers);
		
	}
	
	public void lessSoldier(int idTerritory, int soldiers)
	{
		ArrayList<Territory> listTerritories = ListGames.getGame(this.idGame).getMap();
        Territory aux = new Territory(idTerritory,null,"",-1,null,-1,-1,-1);
        int pos = listTerritories.indexOf(aux);
        Territory t = listTerritories.get(pos);
        t.setNumSoldiers(t.getNumSoldiers()-soldiers);
		
	}
}