package ea.domain;

import java.rmi.RemoteException;
import java.util.UUID;
import domain.Arsenal;
import exceptions.GameNotFoundException;
import exceptions.InvalidSessionException;
import exceptions.InvalidTerritoryException;

public class QueryAttack {

	private UUID session;
	private UUID idGame;
	private int originTerritoryAttack;
	private int destinyTerritoryAttack;
	private int soldiers;
	private int cannonsOneUses;
	private int cannonsTwoUses;
	private int cannonsThreeUses;
	private int ICBM;
	private int missiles;
	private Map gameMap;

	public QueryAttack(UUID session, UUID idGame, int originTerritory,
			int destinyTerritory, int soldiers, int cannonsOneUses,
			int cannonsTwoUses, int cannonsThreeUses, int missiles, int ICBM,  Map gameMap) {
		
		this.session = session;
		this.idGame = idGame;
		this.originTerritoryAttack = originTerritory;
		this.destinyTerritoryAttack = destinyTerritory;
		this.soldiers = soldiers;
		this.cannonsOneUses = cannonsOneUses;
		this.cannonsTwoUses = cannonsTwoUses;
		this.cannonsThreeUses = cannonsThreeUses;
		this.ICBM = ICBM;
		this.missiles = missiles;
		this.gameMap = gameMap;
	}

	public void sendAttack() throws RemoteException, GameNotFoundException,
			InvalidSessionException, InvalidTerritoryException {
		Connection.getConnection()
				.attackTerritory(
						this.getSession(),
						this.getIdGame(),
						getGameMap().getTerritory(this.getOriginTerritoryAttack()),
						getGameMap().getTerritory(this.getDestinyTerritoryAttack()),
						new Arsenal(this.getSoldiers(),
								(this.getCannonsOneUses()
										+ this.getCannonsTwoUses()*2 + this
										.getCannonsThreeUses()*3), this.getMissiles(), this.getICBM()));
	}

	public UUID getSession() {
		return session;
	}

	public void setSession(UUID session) {
		this.session = session;
	}

	public UUID getIdGame() {
		return idGame;
	}

	public void setIdGame(UUID idGame) {
		this.idGame = idGame;
	}

	public int getOriginTerritoryAttack() {
		return originTerritoryAttack;
	}

	public void setOriginTerritoryAttack(int originTerritoryAttack) {
		this.originTerritoryAttack = originTerritoryAttack;
	}

	public int getDestinyTerritoryAttack() {
		return destinyTerritoryAttack;
	}

	public void setDestinyTerritoryAttack(int destinyTerritoryAttack) {
		this.destinyTerritoryAttack = destinyTerritoryAttack;
	}

	public int getCannonsOneUses() {
		return cannonsOneUses;
	}

	public void setCannonsOneUses(int cannonsOneUses) {
		this.cannonsOneUses = cannonsOneUses;
	}

	public int getCannonsTwoUses() {
		return cannonsTwoUses;
	}

	public void setCannonsTwoUses(int cannonsTwoUses) {
		this.cannonsTwoUses = cannonsTwoUses;
	}

	public int getCannonsThreeUses() {
		return cannonsThreeUses;
	}

	public void setCannonsThreeUses(int cannonsThreeUses) {
		this.cannonsThreeUses = cannonsThreeUses;
	}

	public void setSoldiers(int soldiers) {
		this.soldiers = soldiers;
	}

	public int getSoldiers() {
		return soldiers;
	}

	public Map getGameMap() {
		return gameMap;
	}

	public void setGameMap(Map gameMap) {
		this.gameMap = gameMap;
	}

	public int getICBM() {
		return ICBM;
	}

	public void setICBM(int iCBM) {
		ICBM = iCBM;
	}

	public int getMissiles() {
		return missiles;
	}

	public void setMissiles(int missiles) {
		this.missiles = missiles;
	}
}
