package ea.domain;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.UUID;

import domain.Game;
import domain.Player;
import domain.Spy;
import domain.Territory;
import ea.libs.Constants;

public class QueryPlayers {
	private Game game;
	public QueryPlayers(UUID idgame)
	{
		game = ListGames.getGame(idgame);
	}

	public ArrayList<String> getListPlayers()
	{
		ArrayList<String> results = new ArrayList<String>();
		
		Iterator<Player> i = game.getPlayers().iterator();
		while(i.hasNext())
		{
			Player p = i.next();
			results.add(p.getName());
		}
		return results;
	}
	
	public ArrayList<String> getListPlayersOnline()
	{
		ArrayList<String> results = new ArrayList<String>();
		
		Iterator<Player> i = game.getPlayers().iterator();
		while(i.hasNext())
		{
			Player p = i.next();
			if(p.isOnline())
				results.add(p.getName());
		}
		return results;
	}
	
	public boolean ishasMyTurn(String player)
	{
		ArrayList<Player> listPlayers = game.getPlayers();
		Player aux = new Player(player, -1);
		int pos = listPlayers.indexOf(aux);
		if(pos != -1)
			return listPlayers.get(pos).isHasTurn();
		else
			return false;
	}
	
	public int posTurnPlayer()
	{
		int position = 0;
		Iterator<Player> i = game.getPlayers().iterator();
		while(i.hasNext())
		{
			Player p = i.next();
			if(p.isHasTurn())
				return position;
			position++;
		}
		return -1;//Error
	}
	
	public ArrayList<String> getListPlayersOffline()
	{
		ArrayList<String> results = new ArrayList<String>();
		
		Iterator<Player> i = game.getPlayers().iterator();
		while(i.hasNext())
		{
			Player p = i.next();
			if(!p.isOnline())
				results.add(p.getName());
		}
		return results;
	}
	
	public int getMoney(String player)
	{
		ArrayList<Player> listPlayers = game.getPlayers();
		Player aux = new Player(player, -1);
		int pos = listPlayers.indexOf(aux);
		if(pos != -1)
			return listPlayers.get(pos).getMoney();
		else
			return -1;
	}
	
}
