package ea.libs;

import exceptions.ColorOutRangeException;

public class Color{
	private int a;
	private int r;
	private int g;
	private int b;
	
	public Color(int a, int r, int g, int b){
		try{
			this.setA(a);
			this.setB(b);
			this.setG(g);
			this.setR(r);
		}catch(ColorOutRangeException e){System.out.println(e.toString());}
	}

	public int getA() {
		return a;
	}

	private void setA(int a)throws ColorOutRangeException {
		if (a >= 0 && a <= 255)
			this.a = a;
		else throw new ColorOutRangeException("Invalid Color");
	}

	public int getR() {
		return r;
	}

	private void setR(int r)throws ColorOutRangeException {
		if (r >= 0 && r <= 255)
			this.r = r;
		else throw new ColorOutRangeException("Invalid Color");
	}

	public int getG() {
		return g;
	}

	private void setG(int g)throws ColorOutRangeException {
		if (g >= 0 && g <= 255)
			this.g = g;
		else throw new ColorOutRangeException("Invalid Color");
	}

	public int getB() {
		return b;
	}

	private void setB(int b)throws ColorOutRangeException {
		if (b >= 0 && b <= 255)
			this.b = b;
		else throw new ColorOutRangeException("Invalid Color");
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + a;
		result = prime * result + b;
		result = prime * result + g;
		result = prime * result + r;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Color other = (Color) obj;
		if (a != other.a)
			return false;
		if (b != other.b)
			return false;
		if (g != other.g)
			return false;
		if (r != other.r)
			return false;
		return true;
	}
	
	
}
