package ea.libs.graphs;

public class Arco<X,C> {
    private Vertice<X> origen,destino;
    private C peso=null ;
    public Arco(Vertice<X> or,Vertice<X> dest,C caracteristicas){
        origen=or;
        destino=dest;
        peso=caracteristicas;
    }
    public Arco(X or,X dest,C p){
        this(new Vertice<X>(or),new Vertice<X>(dest),p);
    }
    public Arco(Vertice<X> or,Vertice<X> dest){
        origen=or;
        destino=dest;
        peso=null ;
    }
    public Arco(X or,X dest){
        this(new Vertice<X> (or), new Vertice<X>(dest)) ;
    }
    public String toString(){
        String s="("+origen.identificador().toString()+","
                +destino.identificador().toString();
        if (peso!=null ) s=s+"<"+peso+">";
        s=s+")";
        return s;
    }
    public Vertice<X> origen(){
        return origen;
    }
    public Vertice<X> destino(){
        return destino;
    }
    public C peso(){
        return peso;
    }
    public void nuevoPeso(C p){
        peso=p;
    }
    
    @SuppressWarnings("unchecked")
	public boolean equals(Object a){
        return a instanceof Arco && origen().equals(((Arco<X,C>)a).
                origen()) && destino().equals(((Arco<X,C>)a).destino());
    }
}