package ea.libs.graphs;

import ea.libs.lists.*;


public abstract class Grafo<X,C>{
//Clase que representa grafos
//X representa el tipo de elemento de los vrtices
//C son los pesos de los arcos. Si no es valorado peso==null
    private boolean dirigido;
    public Grafo(){
        dirigido=false ;
    }
    public Grafo(boolean b){
        dirigido=b;
    }
    public boolean dirigido(){
        return dirigido;
    }
    public abstract boolean esVacio();
    public abstract void insertarVertice(X v);
    public abstract void insertarVertice(Vertice<X> v);
    public abstract void insertarArco(Arco<X,C> a);
    public abstract void insertarArco(X origen,X destino);
    public abstract void insertarArco(X origen,X destino,C c);
    public boolean perteneceVertice(Vertice<X> v){
        return vertices().pertenece(v);
    }
    public abstract boolean perteneceVertice(X identificador);
    public boolean perteneceArco(Arco<X,C> a){
        
        return arcos().pertenece(a);
    }
    public abstract boolean perteneceArco(X origen,X destino);
    public abstract Lista<Vertice<X>> adyacentes(Vertice<X> v);
    public abstract Lista<Arco<X,C>> arcosAdyacentes(Vertice<X> v);
    public abstract Lista<Vertice<X>> incidentes(Vertice<X> v);
    public abstract Lista<Arco<X,C>> arcosIncidentes(Vertice<X> v);
    public abstract Lista<Vertice<X>> vertices();
    public abstract Lista<Arco<X,C>> arcos();
    public int numVertices(){
        return vertices().longitud();
    }
    public int numArcos(){
        return arcos().longitud();
    }
    public String toString(){
        return "vertices..."+vertices().toString()+"\n arcos..."+arcos().
                toString();
    }
    public abstract void eliminaVertice(Vertice<X> v);
    public abstract void eliminaVertice(X v);
    public abstract void eliminaArco(Arco<X,C> a);
    public abstract void eliminaArco(X origen, X destino);
    public Lista<Vertice<X>> recorrido(){
        Lista<Vertice<X>> visitados=new Lista<Vertice<X>>();
        for (int n=1;n<=vertices().longitud();n++)
            if (!visitados.pertenece(vertices().elementoN(n)))
                rep(visitados,vertices().elementoN(n));
        return visitados;
    }
    private void rep(Lista<Vertice<X>> visitados, Vertice<X> v){
        visitados.insertarFinal(v);
        for (int n=1;n<=adyacentes(v).longitud();n++)
            if (!visitados.pertenece(adyacentes(v).elementoN(n)))
                rep(visitados,(adyacentes(v).elementoN(n)));
    }
}
