package ea.libs.lists;

public class Lista<Elemento> implements Cloneable {
    private Elemento dato;
    private Lista<Elemento> resto;

    public Lista() {
        dato=null;
        resto=null;
    }
    public Lista (Elemento ob, Lista <Elemento>l){
        dato=ob;
        resto=l;
    }
    public Lista (Elemento ob){
        this(ob,new Lista<Elemento>());
    }
    public boolean esVacia(){
        return dato==null;
    }
    public Elemento primero (){
        if (esVacia ()) return null;
        else return dato;
    }
    protected void setPrimero(Elemento ob){
        dato=ob;
    }
    protected void setResto(Lista <Elemento>l){
        resto=l;
    }
    public Lista<Elemento> resto (){
        if (esVacia ()) return this;
        else return resto;
    }
    public void insertarPrincipio (Elemento ob){
        if (esVacia ()) setResto (new Lista<Elemento>());
        else setResto (new Lista<Elemento>(primero (),resto()));
        setPrimero(ob);
    }
    public void eliminaPrimero(){
        if (!esVacia()){
            setPrimero (resto().primero());
            setResto (resto().resto());
        }
    }
    public void elimina(Elemento ob){
        if (!esVacia()){
            if (primero().equals(ob)) eliminaPrimero();
            else resto().elimina(ob);
        }
    }
    public Lista<Elemento> clone(){
        Lista<Elemento>copia=new Lista<Elemento>();
        if(!esVacia()){
            copia=resto().clone();
            copia.insertarPrincipio(primero());
        }
        return copia;
    }
    public String toString(){
        String s=" ";
        if(!esVacia()) s=s+primero().toString()+resto().toString();
        return s;
    }
    
    @SuppressWarnings("unchecked")
    public boolean equals(Object lista){
        boolean iguales=false;
        if (lista instanceof Lista){
			Lista<Elemento> L=(Lista<Elemento>)lista;
            if ((esVacia () && L.esVacia()) || this==L) iguales=true;
            else
                if ((!esVacia()&&L.esVacia()) || (esVacia() && !L.esVacia())) iguales=false;
                else iguales=primero().equals(L.primero()) && resto().equals(L.resto());
        }
        return iguales;
    }
    public int longitud(){
        int n=0;
        if(!esVacia()) n=1+resto().longitud();
        return n;
    }
    public Elemento ultimo () throws listaVaciaException{
        if (esVacia()) throw new listaVaciaException();
        else if(resto().esVacia()) return primero();
            else return resto().ultimo();
    }
    public Elemento elementoN(int n){
        if(esVacia() || n<1) return null;
        else if(n==1) return primero();
             else return resto().elementoN(n-1);
    }
    public boolean pertenece(Elemento ob){
        return (!esVacia()) && ((primero().equals(ob) || resto().pertenece(ob)));
    }
    public int posicion (Elemento ob){
        int p=1;
        Lista <Elemento>aux=this;
        while(!aux.esVacia() && !ob.equals(aux.primero())){
            p++;
            aux=aux.resto();
        }
        if(aux.esVacia()) p=0;
        return p;
    }
    public void insertarFinal (Elemento ob){
        if(esVacia()) insertarPrincipio (ob);
        else resto().insertarFinal(ob);
    }
    public void insertarN (Elemento ob,int n){
        if(n>0){
            if(esVacia() || n==1) insertarPrincipio (ob);
            else resto().insertarN(ob,n-1);
        }
    }
    public void concatenar(Lista<Elemento>l){
        if (!l.esVacia() && l!=this){
            insertarFinal (l.primero());
            concatenar(l.resto());
        }
    }
    public void eliminaUltimo(){
        if(!esVacia()){
            if(resto().esVacia()) eliminaPrimero();
            else resto().eliminaUltimo();
        }
    }
    public void eliminaN(int n){
        if(!esVacia() && n>0){
            if(n==1)eliminaPrimero();
            else resto().eliminaN(n-1);
        }
    }
    public void modificaN(Elemento ob, int n){
        eliminaN(n);
        insertarN(ob,n);
    }
    public void modificaPrimero(Elemento ob){
        modificaN(ob,1);
    }
    public void modificaObjeto (Elemento actual,Elemento nuevo){
        if(pertenece(actual)) modificaN (nuevo,posicion(actual));
    }
    
    @SuppressWarnings({ "unchecked", "rawtypes" })
	private void coloca (Elemento ob){
        if(esVacia() || ((Comparable)primero()).compareTo(ob)>0)
            insertarPrincipio(ob);
        else resto().coloca(ob);
    }
    public Lista<Elemento>ordena(){
        Lista<Elemento>ordenada=new Lista<Elemento>();
        if(!esVacia()){
            ordenada=resto().ordena();
            ordenada.coloca(primero());
        }
        return ordenada;
    }
}