package ea.presentation;

import com.trolltech.qt.core.Qt;
import com.trolltech.qt.gui.QCloseEvent;
import com.trolltech.qt.gui.QDesktopWidget;
import com.trolltech.qt.gui.QGridLayout;
import com.trolltech.qt.gui.QGroupBox;
import com.trolltech.qt.gui.QHBoxLayout;
import com.trolltech.qt.gui.QIcon;
import com.trolltech.qt.gui.QLabel;
import com.trolltech.qt.gui.QPushButton;
import com.trolltech.qt.gui.QSpinBox;
import com.trolltech.qt.gui.QVBoxLayout;
import com.trolltech.qt.gui.QWidget;

import ea.domain.Connection;
import ea.domain.Names;
import ea.domain.QueryMoney;
import ea.libs.Constants;

public class MenuBuyTerritory extends QWidget
{
	private Match father;
	
	private QLabel numSoldiersTerritoryOrigin; 
	private QLabel numCannonsTerritoryOneUseOrigin; 
	private QLabel numCannonsTerritoryTwoUsesOrigin; 
	private QLabel numCannonsTerritoryThreeUsesOrigin; 
	private QLabel numMissilesTerritoryOrigin;
	private QLabel numICBMsTerritoryOrigin;
	private QLabel numAntiMissilesTerritoryOrigin;
	
	private QLabel numSoldiersTerritoryDestine; 
	private QLabel numCannonsTerritoryOneUseDestine; 
	private QLabel numCannonsTerritoryTwoUsesDestine; 
	private QLabel numCannonsTerritoryThreeUsesDestine; 
	private QLabel numMissilesTerritoryDestine;
	private QLabel numICBMsTerritoryDestine;
	private QLabel numAntiMissilesTerritoryDestine;
	
	private QLabel totalSoldiersOrigin; 
	private QLabel totalCannonsOneUseOrigin; 
	private QLabel totalCannonsTwoUsesOrigin; 
	private QLabel totalCannonsThreeUsesOrigin; 
	private QLabel totalMissilesOrigin;
	private QLabel totalICBMsOrigin;
	private QLabel totalAntiMissilesOrigin;
	
	private QLabel totalSoldiersDestine; 
	private QLabel totalCannonsOneUseDestine; 
	private QLabel totalCannonsTwoUsesDestine; 
	private QLabel totalCannonsThreeUsesDestine; 
	private QLabel totalMissilesDestine;
	private QLabel totalICBMsDestine;
	private QLabel totalAntiMissilesDestine;
	
	private QLabel incrementSoldiersDestine; 
	private QLabel incrementCannonsOneUseDestine; 
	private QLabel incrementCannonsTwoUsesDestine; 
	private QLabel incrementCannonsThreeUsesDestine; 
	private QLabel incrementMissilesDestine;
	private QLabel incrementICBMsDestine;
	private QLabel incrementAntiMissilesDestine;
	
	public MenuBuyTerritory(Match father)
	{
		this.father = father;
		this.createMainWindow();
		this.createBoxMove();
		show();
	}
	
	private int getIdTerritoryOrigin()
	{
		return this.father.getPendingAction().getOriginTerritory();
	}
	
	private int getIdTerritoryDestine()
	{
		return this.father.getPendingAction().getDestinyTerritory();
	}
	
	private String getNumSoldiers(int idTerritory)
	{
		return String.valueOf(this.father.getMapGame().getMapTerritories().getNumSoldiersTerritorySelected(idTerritory));
	}
	
	private int[] getNumCannons(int idTerritory)
	{
		return this.father.getMapGame().getMapTerritories().getNumCannonsTerritorySelected(idTerritory);
	}
	
	private String getNumMissiles(int idTerritory)
	{
		return String.valueOf(this.father.getMapGame().getMapTerritories().getNumMissilesTerritorySelected(idTerritory));
	}
		
	private String getNumICBMs(int idTerritory)
	{
		return String.valueOf(this.father.getMapGame().getMapTerritories().getNumICBMsTerritorySelected(idTerritory));
	}
		
	private String getNumAntiMissiles(int idTerritory)
	{
		return String.valueOf(this.father.getMapGame().getMapTerritories().getNumAntiMissilesTerritorySelected(idTerritory));
	}
			
	private void createMainWindow()
	{
		setWindowIcon(new QIcon(CommonConstants.APP_ICON));
		setWindowTitle(CommonConstants.APP_NAME + " - Mover unidades");
		QDesktopWidget qdw = new QDesktopWidget();
        int screen_center_width  = (qdw.width() - 250) / 2,
            screen_center_height = (qdw.height() - 300) / 2;
        setGeometry(screen_center_width, screen_center_height, 
        			250, 100);
        
        setWindowModality(Qt.WindowModality.ApplicationModal);
        setWindowFlags(Qt.WindowType.WindowCloseButtonHint);
    	setStyleSheet("background-color:qlinearGradient(x1:0, y1:0, x2:0, y2:1, stop:0 #57360f, " +
			      "stop:1 #9f7340); color: #eeeeff; QLineEdit{background-color:#fffcca;border-radius:7px;" +
			      "border:1px solid black;padding:3px;color:#836b23}");
	}
	
	private QLabel sLabel(String data)
	{  // Create a simple label, without background color associated
		QLabel label = new QLabel(data);
		label.setStyleSheet("background-color:none;");
		return label;
	}
	
	private void createBoxMove()
	{
		QVBoxLayout vbox = new QVBoxLayout();
		vbox.addStretch(1);
		vbox.addWidget(createGroupBoxUp());
		vbox.addWidget(createGroupBoxDown());
		vbox.addLayout(createButtonsLayout());
		
		this.setLayout(vbox);
	}
	
	private QGroupBox createGroupBoxUp()
	{
		QGridLayout grid = new QGridLayout(this);
		
		// Soldiers row
        grid.addWidget(sLabel("N soldados"), 0, 0);
        
        this.numSoldiersTerritoryDestine = sLabel(new Integer(getNumSoldiers(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.numSoldiersTerritoryDestine, 0, 1, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("+"), 0, 2, Qt.AlignmentFlag.AlignCenter);
        
        this.incrementSoldiersDestine = sLabel(new Integer(0).toString());
        grid.addWidget(this.incrementSoldiersDestine, 0, 3, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 0, 4, Qt.AlignmentFlag.AlignCenter);
        
        this.totalSoldiersDestine = sLabel(new Integer(getNumSoldiers(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.totalSoldiersDestine, 0, 5, Qt.AlignmentFlag.AlignRight);
        
		// Cannons 1 use row
        grid.addWidget(sLabel("N caones de 1 uso"), 1, 0);
        
        this.numCannonsTerritoryOneUseDestine = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getDestinyTerritory())[0]));
        grid.addWidget(this.numCannonsTerritoryOneUseDestine, 1, 1, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("+"), 1, 2, Qt.AlignmentFlag.AlignCenter);
        
        this.incrementCannonsOneUseDestine = sLabel(new Integer(0).toString());
        grid.addWidget(this.incrementCannonsOneUseDestine, 1, 3, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 1, 4, Qt.AlignmentFlag.AlignCenter);
        
        this.totalCannonsOneUseDestine = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getDestinyTerritory())[0]));
        grid.addWidget(this.totalCannonsOneUseDestine, 1, 5, Qt.AlignmentFlag.AlignRight);
        
		// Cannons 2 uses row
        grid.addWidget(sLabel("N caones de 2 usos"), 2, 0);
        
        this.numCannonsTerritoryTwoUsesDestine = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getDestinyTerritory())[1]));
        grid.addWidget(this.numCannonsTerritoryTwoUsesDestine, 2, 1, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("+"), 2, 2, Qt.AlignmentFlag.AlignCenter);
        
        this.incrementCannonsTwoUsesDestine = sLabel(new Integer(0).toString());
        grid.addWidget(incrementCannonsTwoUsesDestine, 2, 3, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 2, 4, Qt.AlignmentFlag.AlignCenter);
        
        this.totalCannonsTwoUsesDestine = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getDestinyTerritory())[1]));
        grid.addWidget(totalCannonsTwoUsesDestine, 2, 5, Qt.AlignmentFlag.AlignRight);
        
		// Cannons 3 uses row
        grid.addWidget(sLabel("N caones de 3 usos"), 3, 0);
        
        this.numCannonsTerritoryThreeUsesDestine = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getDestinyTerritory())[2]));
        grid.addWidget(numCannonsTerritoryThreeUsesDestine, 3, 1, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("+"), 3, 2, Qt.AlignmentFlag.AlignCenter);
        
        this.incrementCannonsThreeUsesDestine = sLabel(new Integer(0).toString());
        grid.addWidget(incrementCannonsThreeUsesDestine, 3, 3, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 3, 4, Qt.AlignmentFlag.AlignCenter);
        
        this.totalCannonsThreeUsesDestine = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getDestinyTerritory())[2]));
        grid.addWidget(totalCannonsThreeUsesDestine, 3, 5, Qt.AlignmentFlag.AlignRight);
        
		// Missiles row
        grid.addWidget(sLabel("N misiles"), 4, 0);
        
        this.numMissilesTerritoryDestine = sLabel(new Integer(getNumMissiles(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.numMissilesTerritoryDestine, 4, 1, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("+"), 4, 2, Qt.AlignmentFlag.AlignCenter);
        
        this.incrementMissilesDestine = sLabel(new Integer(0).toString());
        grid.addWidget(this.incrementMissilesDestine, 4, 3, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 4, 4, Qt.AlignmentFlag.AlignCenter);
       
        this.totalMissilesDestine = sLabel(new Integer(getNumMissiles(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.totalMissilesDestine, 4, 5, Qt.AlignmentFlag.AlignRight);
        
		// Missiles ICBM row
        grid.addWidget(sLabel("N misiles ICBM"), 5, 0);
        
        this.numICBMsTerritoryDestine = sLabel(new Integer(getNumICBMs(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.numICBMsTerritoryDestine, 5, 1, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("+"), 5, 2, Qt.AlignmentFlag.AlignCenter);
        
        this.incrementICBMsDestine = sLabel(new Integer(0).toString());
        grid.addWidget(this.incrementICBMsDestine, 5, 3, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 5, 4, Qt.AlignmentFlag.AlignCenter);
        
        this.totalICBMsDestine = sLabel(new Integer(getNumICBMs(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.totalICBMsDestine, 5, 5, Qt.AlignmentFlag.AlignRight);
        
		// Anti Missiles row
        grid.addWidget(sLabel("N anti misiles"), 6, 0);
        
        this.numAntiMissilesTerritoryDestine = sLabel(new Integer(getNumAntiMissiles(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.numAntiMissilesTerritoryDestine, 6, 1, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("+"), 6, 2, Qt.AlignmentFlag.AlignCenter);
        
        this.incrementAntiMissilesDestine = sLabel(new Integer(0).toString());
        grid.addWidget(this.incrementAntiMissilesDestine, 6, 3, Qt.AlignmentFlag.AlignRight);
       
        grid.addWidget(sLabel("="), 6, 4, Qt.AlignmentFlag.AlignCenter);
        
        this.totalAntiMissilesDestine = sLabel(new Integer(getNumAntiMissiles(
        		this.father.getPendingAction().getDestinyTerritory())).toString());
        grid.addWidget(this.totalAntiMissilesDestine, 6, 5, Qt.AlignmentFlag.AlignRight);
        
        QGroupBox groupBox = new QGroupBox("Territorio destino del movimiento: " + Names.values()[this.father.getPendingAction().getDestinyTerritory()]);
        groupBox.setLayout(grid);
        return groupBox;
	}
	
	private QGroupBox createGroupBoxDown()
	{
		QGridLayout grid = new QGridLayout(this);
		
		// Soldiers row		
        grid.addWidget(sLabel("N soldados"), 0, 0);
        grid.addWidget(sLabel("="), 0, 1, Qt.AlignmentFlag.AlignCenter);
        
        this.numSoldiersTerritoryOrigin = sLabel(new Integer(getNumSoldiers(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(this.numSoldiersTerritoryOrigin, 0, 2, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("-"), 0, 3, Qt.AlignmentFlag.AlignCenter);
        
        QSpinBox spinBoxSoldiers = new QSpinBox();
		spinBoxSoldiers.setMinimum(0);
		spinBoxSoldiers.setMaximum(Integer.parseInt(this.numSoldiersTerritoryOrigin.text())-1);
		spinBoxSoldiers.valueChanged.connect(this, "onChangeSoldiers(int)");
        grid.addWidget(spinBoxSoldiers, 0, 4, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 0, 5, Qt.AlignmentFlag.AlignCenter);
        
        this.totalSoldiersOrigin = sLabel(new Integer(getNumSoldiers(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(this.totalSoldiersOrigin, 0, 6, Qt.AlignmentFlag.AlignRight);
        
		// Cannons 1 use row
        grid.addWidget(sLabel("N caones de 1 uso"), 1, 0);
        grid.addWidget(sLabel("="), 1, 1, Qt.AlignmentFlag.AlignCenter);
        
        this.numCannonsTerritoryOneUseOrigin = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getOriginTerritory())[0]));
        grid.addWidget(this.numCannonsTerritoryOneUseOrigin, 1, 2, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("-"), 1, 3, Qt.AlignmentFlag.AlignCenter);
        
        
        QSpinBox spinBoxCannons1 = new QSpinBox();
        spinBoxCannons1.setMinimum(0);
        spinBoxCannons1.setMaximum(Integer.parseInt(this.numCannonsTerritoryOneUseOrigin.text()));
        spinBoxCannons1.valueChanged.connect(this, "onChangeCannonsOneUse(int)");
        grid.addWidget(spinBoxCannons1, 1, 4, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 1, 5, Qt.AlignmentFlag.AlignCenter);
        
        this.totalCannonsOneUseOrigin = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getOriginTerritory())[0]));
        grid.addWidget(this.totalCannonsOneUseOrigin, 1, 6, Qt.AlignmentFlag.AlignRight);
        
		// Cannons 2 uses row
        grid.addWidget(sLabel("N caones de 2 usos"), 2, 0);
        grid.addWidget(sLabel("="), 2, 1, Qt.AlignmentFlag.AlignCenter);
        
        this.numCannonsTerritoryTwoUsesOrigin = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getOriginTerritory())[1]));
        grid.addWidget(this.numCannonsTerritoryTwoUsesOrigin, 2, 2, Qt.AlignmentFlag.AlignRight);
       
        grid.addWidget(sLabel("-"), 2, 3, Qt.AlignmentFlag.AlignCenter);
        
        
        QSpinBox spinBoxCannons2 = new QSpinBox();
        spinBoxCannons2.setMinimum(0);
        spinBoxCannons2.setMaximum(Integer.parseInt(this.numCannonsTerritoryTwoUsesOrigin.text()));
        spinBoxCannons2.valueChanged.connect(this, "onChangeCannonsTwoUses(int)");
        grid.addWidget(spinBoxCannons2, 2, 4, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 2, 5, Qt.AlignmentFlag.AlignCenter);
        this.totalCannonsTwoUsesOrigin = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getOriginTerritory())[1]));
        grid.addWidget(this.totalCannonsTwoUsesOrigin, 2, 6, Qt.AlignmentFlag.AlignRight);
        
		// Cannons 3 uses row
        grid.addWidget(sLabel("N caones de 3 usos"), 3, 0);
        grid.addWidget(sLabel("="), 3, 1, Qt.AlignmentFlag.AlignCenter);
        
        this.numCannonsTerritoryThreeUsesOrigin = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getOriginTerritory())[2]));
        grid.addWidget(this.numCannonsTerritoryThreeUsesOrigin, 3, 2, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("-"), 3, 3, Qt.AlignmentFlag.AlignCenter);
        
        QSpinBox spinBoxCannons3 = new QSpinBox();
        spinBoxCannons3.setMinimum(0);
        spinBoxCannons3.setMaximum(Integer.parseInt(this.numCannonsTerritoryThreeUsesOrigin.text()));
        spinBoxCannons3.valueChanged.connect(this, "onChangeCannonsThreeUses(int)");
        grid.addWidget(spinBoxCannons3, 3, 4, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 3, 5, Qt.AlignmentFlag.AlignCenter);
        
        this.totalCannonsThreeUsesOrigin = sLabel(String.valueOf(getNumCannons(this.father.getPendingAction().getOriginTerritory())[2]));
        grid.addWidget(this.totalCannonsThreeUsesOrigin , 3, 6, Qt.AlignmentFlag.AlignRight);
        
		// Missiles row
        grid.addWidget(sLabel("N misiles"), 4, 0);
        grid.addWidget(sLabel("="), 4, 1, Qt.AlignmentFlag.AlignCenter);
        
        
        this.numMissilesTerritoryOrigin = sLabel(new Integer(getNumMissiles(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(this.numMissilesTerritoryOrigin, 4, 2, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("-"), 4, 3, Qt.AlignmentFlag.AlignCenter);
        
        QSpinBox spinBoxMissiles = new QSpinBox();
		spinBoxMissiles.setMinimum(0);
		spinBoxMissiles.setMaximum(Integer.parseInt(this.numMissilesTerritoryOrigin.text()));
		spinBoxMissiles.valueChanged.connect(this, "onChangeMissile(int)");
        grid.addWidget(spinBoxMissiles , 4, 4, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 4, 5, Qt.AlignmentFlag.AlignCenter);
        
        this.totalMissilesOrigin = sLabel(new Integer(getNumMissiles(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(this.totalMissilesOrigin, 4, 6, Qt.AlignmentFlag.AlignRight);
        
		// Missiles ICBM row
        grid.addWidget(sLabel("N misiles ICBM"), 5, 0);
        grid.addWidget(sLabel("="), 5, 1, Qt.AlignmentFlag.AlignCenter);

        this.numICBMsTerritoryOrigin = sLabel(new Integer(getNumICBMs(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(this.numICBMsTerritoryOrigin, 5, 2, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("-"), 5, 3, Qt.AlignmentFlag.AlignCenter);
        
        
        QSpinBox spinBoxMissilesICBM = new QSpinBox();
		spinBoxMissilesICBM.setMinimum(0);
		spinBoxMissilesICBM.setMaximum(Integer.parseInt(this.numICBMsTerritoryOrigin.text()));
		spinBoxMissilesICBM.valueChanged.connect(this, "onChangeMissileICBM(int)");
        grid.addWidget(spinBoxMissilesICBM, 5, 4, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 5, 5, Qt.AlignmentFlag.AlignCenter);
        
        this.totalICBMsOrigin = sLabel(new Integer(getNumICBMs(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(totalICBMsOrigin, 5, 6, Qt.AlignmentFlag.AlignRight);
        
		// Anti Missiles row
        grid.addWidget(sLabel("N anti misiles"), 6, 0);
        grid.addWidget(sLabel("="), 6, 1, Qt.AlignmentFlag.AlignCenter);
        
        this.numAntiMissilesTerritoryOrigin = sLabel(new Integer(getNumAntiMissiles(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(this.numAntiMissilesTerritoryOrigin, 6, 2, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("-"), 6, 3, Qt.AlignmentFlag.AlignCenter);
        
        QSpinBox spinBoxAntiMissiles = new QSpinBox();
		spinBoxAntiMissiles.setMinimum(0);
		spinBoxAntiMissiles.setMaximum(Integer.parseInt(this.numAntiMissilesTerritoryOrigin.text()));
		spinBoxAntiMissiles.valueChanged.connect(this, "onChangeAntiMissile(int)");
        grid.addWidget(spinBoxAntiMissiles, 6, 4, Qt.AlignmentFlag.AlignRight);
        
        grid.addWidget(sLabel("="), 6, 5, Qt.AlignmentFlag.AlignCenter);
        
        this.totalAntiMissilesOrigin =  sLabel(new Integer(getNumAntiMissiles(
        		this.father.getPendingAction().getOriginTerritory())).toString());
        grid.addWidget(this.totalAntiMissilesOrigin, 6, 6, Qt.AlignmentFlag.AlignRight);
		
        QGroupBox groupBox = new QGroupBox("Territorio origen del movimiento: "+  Names.values()[this.father.getPendingAction().getOriginTerritory()]);
        groupBox.setLayout(grid);
        return groupBox;
	}
	
	private QHBoxLayout createButtonsLayout()
	{
		QPushButton pushButtonMove = new QPushButton("Comprar");
        pushButtonMove.setIcon(new QIcon(CommonConstants.MOVE_ICON));
        pushButtonMove.clicked.connect(this, "onClickAccept()");
        pushButtonMove.setMaximumWidth(80);
        
        QPushButton buttonExit = new QPushButton("Cancelar");
        buttonExit.setIcon(new QIcon(CommonConstants.CROSS_ICON));
        buttonExit.clicked.connect(this, "onClickCancel()");
        buttonExit.setMaximumWidth(80);
        
        QHBoxLayout buttonsLayout = new QHBoxLayout();
        buttonsLayout.addWidget(pushButtonMove);
        buttonsLayout.addWidget(buttonExit);
        return buttonsLayout;
	}
	
	@SuppressWarnings("unused")
	private void onChangeSoldiers(int value)
	{
		this.incrementSoldiersDestine.setText(String.valueOf(value));
		this.totalSoldiersDestine.setText(String.valueOf(Integer.parseInt(this.numSoldiersTerritoryDestine.text()) + value));
		this.totalSoldiersOrigin.setText(String.valueOf(Integer.parseInt(this.numSoldiersTerritoryOrigin.text()) - value));
	}
	
	@SuppressWarnings("unused")
	private void onChangeCannonsOneUse(int value)
	{
		this.incrementCannonsOneUseDestine.setText(String.valueOf(value));
		this.totalCannonsOneUseDestine.setText(String.valueOf(Integer.parseInt(this.numCannonsTerritoryOneUseDestine.text()) + value));
		this.totalCannonsOneUseOrigin.setText(String.valueOf(Integer.parseInt(this.numCannonsTerritoryOneUseOrigin.text()) - value));
	}
	
	@SuppressWarnings("unused")
	private void onChangeCannonsTwoUses(int value)
	{
		this.incrementCannonsTwoUsesDestine.setText(String.valueOf(value));
		this.totalCannonsTwoUsesDestine.setText(String.valueOf(Integer.parseInt(this.numCannonsTerritoryTwoUsesDestine.text()) + value));
		this.totalCannonsTwoUsesOrigin.setText(String.valueOf(Integer.parseInt(this.numCannonsTerritoryTwoUsesOrigin.text()) - value));
	}
	
	@SuppressWarnings("unused")
	private void onChangeCannonsThreeUses(int value)
	{
		this.incrementCannonsThreeUsesDestine.setText(String.valueOf(value));
		this.totalCannonsThreeUsesDestine.setText(String.valueOf(Integer.parseInt(this.numCannonsTerritoryThreeUsesDestine.text()) + value));
		this.totalCannonsThreeUsesOrigin.setText(String.valueOf(Integer.parseInt(this.numCannonsTerritoryThreeUsesOrigin.text()) - value));
	}
	
	@SuppressWarnings("unused")
	private void onChangeMissile(int value)
	{
		this.incrementMissilesDestine.setText(String.valueOf(value));
		this.totalMissilesDestine.setText(String.valueOf(Integer.parseInt(this.numMissilesTerritoryDestine.text()) + value));
		this.totalMissilesOrigin.setText(String.valueOf(Integer.parseInt(this.numMissilesTerritoryOrigin.text()) - value));
	}
	
	@SuppressWarnings("unused")
	private void onChangeMissileICBM(int value)
	{
		this.incrementICBMsDestine.setText(String.valueOf(value));
		this.totalICBMsDestine.setText(String.valueOf(Integer.parseInt(this.numICBMsTerritoryDestine.text()) + value));
		this.totalICBMsOrigin.setText(String.valueOf(Integer.parseInt(this.numICBMsTerritoryOrigin.text()) - value));		
	}
	
	@SuppressWarnings("unused")
	private void onChangeAntiMissile(int value)
	{
		this.incrementAntiMissilesDestine.setText(String.valueOf(value));
		this.totalAntiMissilesDestine.setText(String.valueOf(Integer.parseInt(this.numAntiMissilesTerritoryDestine.text()) + value));
		this.totalAntiMissilesOrigin.setText(String.valueOf(Integer.parseInt(this.numAntiMissilesTerritoryOrigin.text())-value));
	}
	
	@SuppressWarnings("unused")
	private void onClickCancel()
	{
		this.close();
	}
	
	private boolean atLeastOneSoldier()
	{
		return Integer.parseInt(this.incrementSoldiersDestine.text())==0;
	}
	
	@SuppressWarnings("unused")
	private void onClickAccept()
	{
		if(!atLeastOneSoldier()){
			QueryMoney query = new QueryMoney(this.father.getIdGame(), this.father.getPlayerName());
			query.chargeBuyTerritory(query.getMoney() - Constants.prices[this.getIdTerritoryDestine()]);
			
			this.father.getMapGame().getMapTerritories()
				.buyTerritory(this.getIdTerritoryDestine(), this.father.getPlayerName());
			
			this.father.getMapGame().getMapTerritories()
				.setArsenalTerritory(this.getIdTerritoryOrigin(),
						Integer.parseInt(this.totalSoldiersOrigin.text()),
						Integer.parseInt(this.totalCannonsOneUseOrigin.text()),
						Integer.parseInt(this.totalCannonsTwoUsesOrigin.text()),
						Integer.parseInt(this.totalCannonsThreeUsesOrigin.text()),
						Integer.parseInt(this.totalMissilesOrigin.text()),
						Integer.parseInt(this.totalICBMsOrigin.text()),
						Integer.parseInt(this.totalAntiMissilesOrigin.text()));
						
			this.father.getMapGame().getMapTerritories()
				.setArsenalTerritory(this.getIdTerritoryDestine(),
						Integer.parseInt(this.totalSoldiersDestine.text()),
						Integer.parseInt(this.totalCannonsOneUseDestine.text()),
						Integer.parseInt(this.totalCannonsTwoUsesDestine.text()),
						Integer.parseInt(this.totalCannonsThreeUsesDestine.text()),
						Integer.parseInt(this.totalMissilesDestine.text()),
						Integer.parseInt(this.totalICBMsDestine.text()),
						Integer.parseInt(this.totalAntiMissilesDestine.text()));
			
			Connection.updateGameBuyTerritory(this.father.getIdGame(), this.father.getSession());
			
			new Alert(
					"xito",
					"La compra del territorio se ha llevado con xito.",
					CommonConstants.SUCCESS_ICON);
			
			this.father.buyTerritory();	
			this.close();
		}
		else
			new Alert("Aviso", "Debe de mover al menos algn soldado para realizar la compra.");
	}
	
    @Override
    public void closeEvent(QCloseEvent event)
    {
    	if(CommonConstants.DEBUG) System.out.println("Closing window MenuMove");

    	this.father.getMapGame().cancelMove();
    	this.close();
    }
}
