package ea.presentation;

import com.trolltech.qt.core.Qt;
import com.trolltech.qt.gui.QCloseEvent;
import com.trolltech.qt.gui.QDesktopWidget;
import com.trolltech.qt.gui.QHBoxLayout;
import com.trolltech.qt.gui.QIcon;
import com.trolltech.qt.gui.QLabel;
import com.trolltech.qt.gui.QPushButton;
import com.trolltech.qt.gui.QVBoxLayout;
import com.trolltech.qt.gui.QWidget;

import domain.Arsenal;
import domain.Territory;
import ea.domain.Names;

public class MsgOverAttack extends QWidget implements Runnable
{
	private Match father;
	private int idTerritorySrc;
	private int idTerritoryDst;
	private int soldiers;
	private int cannons;
	private int missiles;
	private int ICBMs;
	

	
	public MsgOverAttack(Match father, int idTerritorySrc, int idTerritoryDst,
			int soldiers, int cannons, int missiles, int ms) {
		super();
		this.father = father;
		this.idTerritorySrc = idTerritorySrc;
		this.idTerritoryDst = idTerritoryDst;
		this.soldiers = soldiers;
		this.cannons = cannons;
		this.missiles = missiles;
		ICBMs = ms;
		this.createMainWindow();
		this.createBox();
		this.show();
	}

	private void createMainWindow()
	{
		setWindowIcon(new QIcon(CommonConstants.APP_ICON));
		setWindowTitle("Defenderse o negociar");
		QDesktopWidget qdw = new QDesktopWidget();
        int screen_center_width  = (qdw.width() - 250) / 2,
            screen_center_height = (qdw.height() - 100) / 2;
        setGeometry(screen_center_width, screen_center_height, 
        			250, 100);
        
        setWindowModality(Qt.WindowModality.ApplicationModal);
        setWindowFlags(Qt.WindowType.WindowCloseButtonHint);
    	setStyleSheet("background-color:qlinearGradient(x1:0, y1:0, x2:0, y2:1, stop:0 #57360f, " +
			      "stop:1 #9f7340); color: #eeeeff; QLineEdit{background-color:#fffcca;border-radius:7px;" +
			      "border:1px solid black;padding:3px;color:#836b23}");
	}
	
	private QLabel sLabel(String data)
	{  // Create a simple label, without background color associated
		QLabel label = new QLabel(data);
		label.setStyleSheet("background-color:none;");
		return label;
	}
	
	private void createBox()
	{
		QVBoxLayout vbox = new QVBoxLayout();
		vbox.addStretch(1);
		vbox.addWidget(createLabelBox(), 1, Qt.AlignmentFlag.AlignTop);
		vbox.addLayout(createButtonsLayout(), 0);
		
		this.setLayout(vbox);
	}
	
	private QLabel createLabelBox()
	{
		String nameAtack = Names.values()[idTerritorySrc].toString();
		String nameDestinityAtack = Names.values()[idTerritoryDst].toString();
		
		QLabel label = sLabel("Te ataca "+nameAtack+" con:\n "+this.soldiers+" soldados, "+
				this.cannons+" caones, "+this.missiles+" misiles y "+this.ICBMs+" ICBM " +
						"sobre tu territorio: "+nameDestinityAtack);
		label.setAlignment(Qt.AlignmentFlag.AlignCenter);
		return label;
	}
	
	private QHBoxLayout createButtonsLayout()
	{
		QPushButton pushButton = new QPushButton("Defender");
		pushButton.setIcon(new QIcon(CommonConstants.DEFENSE_ICON));
		pushButton.setMaximumWidth(80);
		pushButton.clicked.connect(this, "onClickDefense()");
    
		QPushButton button = new QPushButton("Negociar");
		button.setIcon(new QIcon(CommonConstants.NEGOTIATE_ICON));
		button.setMaximumWidth(80);
        button.clicked.connect(this, "onClickNegotiate()");
    
		QHBoxLayout buttonsLayout = new QHBoxLayout();
		buttonsLayout.addWidget(pushButton);
		buttonsLayout.addWidget(button);
		return buttonsLayout;
	}
	
	@SuppressWarnings("unused")
	private void onClickDefense()
	{
		
	}
	
	private void onClickNegotiate()
	{
		//MenuAttack m = new MenuAttack(this.father);
		MenuNegotiate m = new MenuNegotiate(this.father,idTerritoryDst);
		this.close();
	}
	
    @Override
    public void closeEvent(QCloseEvent event)
    {
    	if(CommonConstants.DEBUG) System.out.println("Closing window MsgOverAttack");
    	this.close();
    }
    
    @Override
	public void run() {
		// TODO Auto-generated method stub
		
	}
}
