package ea.test;


import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.UUID;

import junit.framework.TestCase;
import domain.GameInfo;
import exceptions.InvalidSessionException;
import exceptions.UserAlreadyExistsException;
import exceptions.WrongLoginException;
import ea.client.Client;
import ea.libs.domain.Connection;
import ea.libs.exceptions.NullInformationException;
import ea.server.Server;

public class TestCaseDesauthentication extends TestCase
{
    // fixtures
    String user, password;
    Server server;
    Connection conn;
    Client cliente;
    UUID session,sessionnovalida = null;
    GameInfo gi;
    UUID game;

    public void setUp()
    {
    	try {
    		cliente = Connection.getConnection();
    		cliente.registerPlayer("edu", "12345", "edseal20@hotmail.com");
    		session = cliente.loginPlayer("edu", "12345");
    		ArrayList<GameInfo> juegos = cliente.listGames(session);
    		gi = juegos.get(1); 	//Se saca la informacin del primer juego
    		game = gi.getId();		//Se saca el id del juego
    		
		} catch (UserAlreadyExistsException e) {
			e.printStackTrace();
		}catch (java.net.ConnectException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (WrongLoginException e) {
			e.printStackTrace();
		} catch (NullInformationException e) {
			e.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}
    }

    public void testTc1() //Sesin vlida
    {
        try
        {
            cliente.logoutUser(session);
            cliente.joinGame(session, game);
            fail("Se espera InvalidSessionException");
            
        } catch (RemoteException re) {
        	fail(re.toString());
        } catch (InvalidSessionException ise){
        	//El nmero de sesin no pertenece a nadie
        } catch(Exception e) {
            fail(e.toString());
        }
        
    }
    
    public void testTc2() //Sesin no vlida
    {
    	try
        {
            cliente.logoutUser(sessionnovalida);            
            fail("Se espera InvalidSessionException");
        }   
        catch (RemoteException re)
        {
        	fail(re.toString());
        }
        catch (InvalidSessionException ise){
        	assertNull(sessionnovalida);
        }
        catch(Exception e)
        {
            fail(e.toString());
        }
        
    }
    

    public void tearDown()
    {
        cliente = null;
        System.gc();
    }
}
