package ea.test;


import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.UUID;

import junit.framework.TestCase;
import domain.GameInfo;
import exceptions.InvalidSessionException;
import exceptions.UserAlreadyExistsException;
import ea.client.Client;
import ea.libs.domain.Connection;
import ea.server.Server;

public class TestCaseListGames extends TestCase{

	Server server;
    Connection conn;
    UUID game;
    UUID session, sessionnovalida = null;
    Client cliente;
    GameInfo gi;

    public void setUp()
    {
    	try {
    		cliente = Connection.getConnection();
    		cliente.registerPlayer("edu", "12345", "edseal20@hotmail.com");
    		session = cliente.loginPlayer("edu", "12345");
	        
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (UserAlreadyExistsException e) {
			e.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}
    }
    
    public void testTc1(){
    	
    	try{
    		ArrayList<GameInfo> juegos = cliente.listGames(session);
    		assertNotNull(juegos); //Se espera que la lista de juegos no sea nula
    		
    		/*if(juegos.isEmpty()){
    			fail("Se esperaba que la lista tuviera algun juego");
    		}*/
    	} catch (RemoteException re){
    		fail(re.toString());
    	} catch (Exception e){
    		fail(e.toString());
    	}
    }
    
   public void testTc2(){ //Sesin no vlida
    	
    	try{
    		cliente.listGames(sessionnovalida);
    		fail("Se espera InvalidSessionException.");
    		
    	} catch (RemoteException re){
    		fail(re.toString());
    	} catch (Exception e){
    		if(e instanceof InvalidSessionException){
    			assertNull(sessionnovalida);
    		} else{
    			fail(e.toString());
    		}
    	}
    }
		
	public void tearDown() throws Exception {
		cliente = null;
        System.gc();
	}
}
