package ea.test;

import java.net.ConnectException;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.UUID;

import domain.Game;
import domain.GameInfo;
import domain.Player;

import ea.libs.domain.Connection;
import ea.libs.exceptions.NullInformationException;
import exceptions.AlreadyInGameException;
import exceptions.FullGameException;
import exceptions.GameNotFoundException;
import exceptions.InvalidGameInfoException;
import exceptions.InvalidSessionException;
import exceptions.InvalidTimeException;
import exceptions.UserAlreadyExistsException;
import exceptions.WrongLoginException;


import junit.framework.TestCase;

public class TestCaseListUser extends TestCase {
	
	// fixtures
	UUID idValidSession, idInvalidSession, idValidGame, idInvalidGame;
	GameInfo gameInfo;
	ArrayList<Player> players;
	ArrayList<String> playersStr;
	Game game;
	ArrayList<GameInfo> gamesInfo;
	ArrayList<String> ps;
	GameInfo gi;

	public void setUp() {
		this.gi = null;
		this.idValidGame = UUID.randomUUID();
		this.idInvalidGame = UUID.fromString("no valid");
		this.idInvalidSession = UUID.fromString("no valid");
		this.ps = null;
		this.playersStr.add("Luis");	
		this.gameInfo = new GameInfo(this.idValidGame, "testGame", "testGame", 
				this.playersStr, null, 1, 1, 1, 1);
		
		try {
			Connection.getConnection().registerPlayer("Luis", "1234", "luis@alu");
			this.idValidSession = Connection.getConnection().loginPlayer("Luis", "1234");
			Connection.getConnection().createGame(this.gameInfo);
			Connection.getConnection().joinGame(this.idValidSession, this.idValidGame);
			game = Connection.getConnection().playGame(this.idValidSession, this.idValidGame);
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (InvalidGameInfoException e) {
			e.printStackTrace();
		} catch (InvalidSessionException e) {
			e.printStackTrace();
		} catch (ConnectException e) {
			e.printStackTrace();
		} catch (WrongLoginException e) {
			e.printStackTrace();
		} catch (NullInformationException e) {
			e.printStackTrace();
		} catch (UserAlreadyExistsException e) {
			e.printStackTrace();
		} catch (FullGameException e) {
			e.printStackTrace();
		} catch (GameNotFoundException e) {
			e.printStackTrace();
		} catch (AlreadyInGameException e) {
			e.printStackTrace();
		} catch (InvalidTimeException e) {
			e.printStackTrace();
		}		
	}

	public void testCase1() {
		try {
			this.gamesInfo = Connection.getConnection().listGames(this.idValidSession);
			for (int i=0; i<this.gamesInfo.size(); i++)
			{
				gi = this.gamesInfo.get(i);				
				if (gi.getId() == this.idValidGame) {
					ps = gi.getPlayers();					
				}
			}
			
			assertNotNull(ps);
			assertTrue(ps.equals(this.playersStr));
		} catch (RemoteException e) {
			fail("No se esperaba la excepcin: ");
			e.printStackTrace();
		}
	}

	public void testCase2() {
		try {
			this.gamesInfo = Connection.getConnection().listGames(this.idValidSession);
			
			for (int i=0; i<this.gamesInfo.size(); i++)
			{
				gi = this.gamesInfo.get(i);				
				if (gi.getId() == this.idInvalidGame) {
					ps = gi.getPlayers();					
				}				
			}
			assertNull(gi);
		} catch (RemoteException e) {
			fail("No se esperaba la excepcin: ");
			e.printStackTrace();
		}
	}

	public void tearDown() {
		try {
			Connection.getConnection().logoutUser(this.idValidSession);
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (InvalidSessionException e) {
			e.printStackTrace();
		}
	}
}