package ea.test;


import java.net.ConnectException;
import java.rmi.RemoteException;
import java.util.UUID;

import exceptions.UserAlreadyExistsException;
import exceptions.WrongLoginException;
import ea.client.Client;
import ea.libs.domain.Connection;
import ea.libs.exceptions.NullInformationException;
import ea.server.Server;
import junit.framework.TestCase;

public class TestCaseRegisterUser extends TestCase
{	
    // fixtures
    String user, password, email;
    Server server;
    Connection conn;
    UUID session;
    Client cliente;

    public void setUp()
    {
    	try {
    		cliente = Connection.getConnection();
    		cliente.registerPlayer("edu", "12345", "edseal20@hotmail.com");
		} catch (UserAlreadyExistsException e) {
			e.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}
    }

    public void testTc1() //nombre, password y email correctos
    {
        try
        {
            user = "juan";
            password = "1234";
            email = "juan@micasa.es";
            
            cliente.registerPlayer(user, password, email);
            session = cliente.loginPlayer(user, password);
            assertNotNull(session);
        }
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
        }
        catch (ConnectException e) {
        	fail(e.toString());
		} catch (RemoteException e) {
			fail(e.toString());
		} catch (WrongLoginException e) {
			fail(e.toString());
		} catch (NullInformationException e) {
			fail(e.toString());
		} catch (Exception e) {
			fail(e.toString());
		}
    }
    
    public void testTc2(){ //Nombre vlido, password vacio y email vacio
    	try{
    		user = "juan";
    		password = "";
    		email = "";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }
    
    public void testTc3(){ //Nombre vlido, password invlido y email invlido
    	try{
    		user = "juan";
    		password = "";
    		email = "juanhotmail.com";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }
    
    public void testTc4(){ //Nombre vacio, password vlido y email vacio
    	try{
    		user = "";
    		password = "12345";
    		email = "";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }
    
    public void testTc5(){ //Nombre vacio, password vacio y email vlido
    	try{
    		user = "";
    		password = "";
    		email = "juan@hotmail.com";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }
    
    public void testTc6(){ //Nombre vaci, password vacio y email invlido
    	try{
    		user = "";
    		password = "";
    		email = "juanhotmail.com";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }

    public void testTc7(){ //Nombre vacio, password invlido y email vlido
    	try{
    		user = "";
    		password = "";
    		email = "juan@hotmail.com";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }
    
    public void testTc8(){ //Nombre invlido, password vlido y email invlido
    	try{
    		user = "edu";
    		password = "";
    		email = "juanhotmail.com";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }
    
    public void testTc9(){ //Nombre invlido, password vlido y email vlido
    	try{
    		user = "edu";
    		password = "12345";
    		email = "juan@hotmail.com";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }
    
    public void testTc10(){ //Nombre invlido, password invlido y email vacio
    	try{
    		user = "edu";
    		password = "";
    		email = "";
    		
    		cliente.registerPlayer(user, password, email);
    		fail("Se esperaba NullInformationException");
    	}	
        catch (UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
		} catch (Exception e) {
			if(e instanceof NullInformationException || e instanceof WrongLoginException){
				try {
					session = cliente.loginPlayer(user, password);
				} catch (ConnectException e1) {
					fail(e1.toString()); 
				} catch (RemoteException e1) {
					fail(e1.toString());
				} catch (WrongLoginException e1) {
					assertNull(session);
				} catch (NullInformationException e1) {
					assertNull(session);
				}
    		} else{
    			fail(e.toString());
    		}
		}
    }

    public void tearDown()
    {
        // Unregister users registered in the tests
    	cliente = null;
    	System.gc();
    }
}
