package ea.test;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.UUID;

import ea.communication.Game;
import ea.communication.GameInfo;
import ea.communication.Player;
import ea.communication.Spy;
import ea.communication.Territory;
import ea.communication.Territory.Continent;
import ea.communication.exceptions.InvalidGameInfoException;
import ea.communication.exceptions.InvalidSessionException;
import ea.communication.exceptions.UserAlreadyExistsException;
import ea.communication.exceptions.WrongLoginException;
import ea.libs.domain.Connection;
import ea.libs.exceptions.EmptyInformationException;
import ea.libs.exceptions.NullInformationException;
import ea.server.Server;
import junit.framework.TestCase;

public class TestMoveUnits extends TestCase
{
    // fixtures
    Long idGame, idPlayer;
    int idOriginTerritory, idDestinyTerritory;
    int[] units;
    int[] canons = {1,0,0};
    
    //Para el test
    Iterator<GameInfo> gamesInfo;
    ArrayList<GameInfo> gameList;
    int soldiersOriginBefore;
    int soldiersDestinyBefore;
    int missilesOriginBefore;
    int missilesDestinyBefore;
    int[] canonsOriginBefore;
    int[] canonsDestinyBefore;
    
    public void setUp()
    {
    	gameUUID = UUID.randomUUID();
    	units = new int[3];
    	
    	player = new Player("testPlayer", 0, true, true, null);
    	players = new ArrayList<String>();
    	players.add(player.getName());
    	
    	gameInfo = new GameInfo(gameUUID, "testGame", "testGame", players, null, 1, 1, 1, 1);
    	
    	map = new ArrayList<Territory>();
    	origin = new Territory(1, Continent.Europe, player, 1, canons, 1, 1, 1);
    	destiny = new Territory(2, Continent.Europe, player, 1, canons, 1, 1, 1);
    	map.add(origin);
    	map.add(destiny);
    	
    	playersGame = new ArrayList<Player>();
    	playersGame.add(player);
    	game = new Game(gameInfo, map, playersGame);
    	
    	try {
    		server = new Server();
    		server.startServer();    		
    		conn = new Connection("localhost");
    		conn.getConnection().createGame(gameInfo);  		
    		conn.getConnection().registerUser("testPlayer", "0000", "testEmail@test.com");
    		session = conn.getConnection().loginPlayer("testPlayer", "0000");
    		conn.getConnection().joinGame(session, gameUUID);    
    		game = conn.getConnection().playGame(session, gameUUID);
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (NullInformationException e) {
			e.printStackTrace();
		} catch (EmptyInformationException e) {
			e.printStackTrace();
		} catch (InvalidGameInfoException e) {
			e.printStackTrace();
		} catch (UserAlreadyExistsException e) {
			e.printStackTrace();
		} catch (WrongLoginException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}   
		
    }

    //moveUnits(game_id:long, player_id:long, territory_origin_id:int, territory_destiny_id:int, units:int[])
    public void testMoveUnits()
    {
        try
        {
            idGame = new Long(100);
            idPlayer = new Long(12);
            units = new int[3];
            units[0] = 1;
            units[1] = 1;
            units[2] = 1;
            idOriginTerritory = 1;
            idDestinyTerritory = 2;
            
            conn.getConnection().moveUnits(idGame, idPlayer, idOriginTerritory, idDestinyTerritory, units);
            
            //Volver a recuperar la partida y ver si se han movido
            //No s con qu operacin volveramos a tener el Game actualizado para mostrar al usuario
            /*
            gameList = conn.getConnection().listGames();
            gamesInfo = gameList.iterator();
            while (gamesInfo.hasNext()) {
                GameInfo g = gamesInfo.next();
                if(g.getId()==gameUUID){
                	conn.getConnection().
                	soldiersOriginBefore = g.;
                    soldiersDestinyBefore;
                    missilesOriginBefore;
                    missilesDestinyBefore;
                    canonsOriginBefore;
                    canonsDestinyBefore;
                }
              }
            
            */
            
            assertTrue(true);
        }
        catch(Exception e)
        {
            fail(e.toString());
        }
    }

    public void tearDown()
    {
        // ...
    }
}