package ea.test;
import java.rmi.RemoteException;
import java.util.UUID;

import ea.libs.exceptions.EmptyInformationException;
import ea.communication.exceptions.UserAlreadyExistsException;
import ea.libs.domain.Connection;
import ea.libs.exceptions.EmptyInformationException;
import ea.server.Server;
import exceptions.UserAlreadyExistsException;
import junit.framework.TestCase;

public class TestRegister extends TestCase
{	
    // fixtures
    String userName, password, email;
    Server server;
    Connection conn;
    UUID session;

    public void setUp()
    {
    	try {
    		server = new Server();
    		server.startServer();
    		server.registerUser("pepe", "1234", "pepe@micasa.es");
    	}
    	catch (RemoteException e)
    	{
    		e.printStackTrace();
    	}
    	catch (EmptyInformationException e)
    	{
    		e.printStackTrace();
    	}
    	catch (UserAlreadyExistsException e)
    	{
    		e.printStackTrace();
    	}
    }

    public void testRegisterPlayer()
    {
        try
        {
        	userName = "correctUser";
        	password = "correctPassword";
        	email = "correctEmail";
        	             
        	conn = new Connection("localhost");
        	           
        	conn.getConnection().registerUser(userName, password, email);            
        	assertTrue(true);
        }
        catch(UserAlreadyExistsException ue)
        {
        	fail(ue.toString());
        }
        catch(RemoteException re)
        {
        	fail(re.toString());
        }
        catch(Exception e)
        {
            fail(e.toString());
        }
    }

    public void testRegisterPlayerNeg()
    {
        // Test if the register is undone
        // when the login and pasword are empty
        try
        {
            userName = "";
            password = "";
            email = "";
            
            conn.getConnection().registerUser(userName, password, email);            
            fail("Se esperaba EmptyInformationException");
            
            userName = "defaultUser";
            password = "";
            email = "";
            
            conn.getConnection().registerUser(userName, password, email);            
            fail("Se esperaba EmptyInformationException");
            
            userName = "";
            password = "defaultPassword";
            email = "";
            
            conn.getConnection().registerUser(userName, password, email);            
            fail("Se esperaba EmptyInformationException");
            
            userName = "";
            password = "";
            email = "defaulEmail";
            
            conn.getConnection().registerUser(userName, password, email);            
            fail("Se esperaba EmptyInformationException");
                        
            userName = "pepe";
            password = "1234";
            email = "pepe@micasa.es";
                      
            conn.getConnection().registerUser(userName, password, email);            
            fail("Se esperaba UserAlreadyExistsException");
            
            // [TODO] More combinations
        }
        catch(UserAlreadyExistsException ue)
        {
        	assertTrue(true);
        }
        catch(EmptyInformationException ie)
        {
        	assertTrue(true);
        }
        catch(RemoteException e)
        {
        	fail(e.toString());
        }
        catch (Exception e)
        {
            fail(e.toString());
        }
    }

    public void tearDown()
    {
    	// Unregister users registered in the tests
    }
}